#include "DualCoding/DualCoding.h"
using namespace DualCoding;

class Containment : public VisualRoutinesStateNode {
public:
Containment() : VisualRoutinesStateNode("Containment") {}
    /**
    First get green stuff, second use visops::edge to create a edge sketch from 
    the blobs, then use visops::fillInterior to get the interior of the polygon
    and & it with pink blobs to get the desired sketch.
    */
    void DoStart() {
        camSkS.clear();
        NEW_SKETCH(camFrame, uchar, sketchFromSeg());
        NEW_SKETCH(green_stuff, bool, visops::colormask(camFrame,"green"));
        NEW_SKETCH(green_edge, bool, visops::edge(green_stuff));

        NEW_SKETCH(green_int, bool, visops::fillInterior(green_edge));

        NEW_SKETCH(pink_stuff, bool, visops::colormask(camFrame,"pink"));

        NEW_SKETCH(result, bool, pink_stuff & green_int)
    }
};
