#include "DualCoding/DualCoding.h"

using namespace DualCoding;

class CountContain : public VisualRoutinesStateNode {
public:
    CountContain() : VisualRoutinesStateNode("CountContain") {}
    /**
    Gets both pink and blue blob inside the green line. 
    */
    void DoStart() {
        camSkS.clear();
        NEW_SKETCH(camFrame, uchar, sketchFromSeg());
        NEW_SKETCH(green_stuff, bool, visops::colormask(camFrame,"green"));
        NEW_SKETCH(green_edge, bool, visops::edge(green_stuff));

        NEW_SKETCH(green_int, bool, visops::fillInterior(green_edge));
        NEW_SKETCH(pink_stuff, bool, visops::colormask(camFrame,"pink"));
        NEW_SKETCH(blue_stuff, bool, visops::colormask(camFrame,"blue"));

        NEW_SKETCH(both, bool pink_stuff | blue_stuff);
        NEW_SKETCH(both_cc, bool, visops::labelcc(both, 10))
        
        NEW_SKETCH(result, bool, both_cc & green_int);
    }
};
