#include "DualCoding/DualCoding.h"
using namespace DualCoding;

class Counting : public VisualRoutinesStateNode {
public:
    Counting() : VisualRoutinesStateNode("Counting") {}
    /**
    Counting the number of blobs by labeling them and pick the max of the 
    labels. 
    */
    void DoStart() {
        camSkS.clear();
        NEW_SKETCH(camFrame, uchar, sketchFromSeg());
        NEW_SKETCH(blue_stuff, bool, visops::colormask(camFrame,"blue"));
        NEW_SKETCH(b_cc, uint, visops::labelcc(blue_stuff, 10));

        int b_max = b_cc->max();

        NEW_SKETCH(pink_stuff, bool, visops::colormask(camFrame,"pink"));
        NEW_SKETCH(p_cc, uint, visops::labelcc(pink_stuff, 10));
        
        int p_max = p_cc->max();
        printf("%d, %d\n", b_max, p_max);
        
        if (b_max>=p_max) {
            NEW_SKETCH(winner, bool, b_cc);
        }
        else {
            NEW_SKETCH(winner, bool, p_cc);
        }
    }
};
